//+------------------------------------------------------------------+
//|															geExtrapolatorBuff.mq4		|
//|                      Copyright  2007, ver 1.0							|
//|                      Forte928           									|
//+------------------------------------------------------------------+
#property copyright "Forte928"
#property link      ""
// geAdaptExtrapolatorBuff"
#define		IndicatorName "geAdaptExpolBuff"
//		  include   Extrapolator
//		    
//
//		ge_AEGlobalValue.mq4
//		ge_OwnerTree.mq4
//		ge_Extrapolator.mq4
//		ge_TicketCtrl.mq4
//		    ..
//
//		      
//		           "_AE_"
#property indicator_chart_window
//#property indicator_separate_window
//#property indicator_minimum -1.5
//#property indicator_maximum 1.5
#property indicator_buffers 8
#property indicator_color1 Turquoise//CadetBlue
#property indicator_color2 Coral//GreenYellow
#property indicator_color3 PaleGreen//GreenYellow
#property indicator_color4 LightSalmon//CadetBlue
#property indicator_color5 PaleGreen//GreenYellow
#property indicator_color6 LightSalmon//GreenYellow
#property indicator_color7 PaleGreen//CadetBlue
#property indicator_color8 LightSalmon//GreenYellow

//---- input parameters
extern int		ID					= 0;
extern int		Present			= 300;
extern int		ForeCast			= 14;
extern int		HarmCount		= 21;
extern int		BarBuffered		= 1;		//    
//extern double  FreqTOL  		=	0.0001;//Tolerance of frequency calculation for Method 1
extern int		Shift				= 0;													// -->
extern int		Counter			= 1000;

//+------------------------------------------------------------+
//+                       					+
//+------------------------------------------------------------+
double	FxView1[];
double	FxView2[];
double	FxView3[];
double	FxView4[];
double	FxView5[];
double	FxView6[];
double	FxView7[];
double	FxView8[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Global Variables ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include <Extrapolator\ge_Extrapolator.mq4>
#include <Extrapolator\ge_TicketCtrl.mq4>													// -->
#include <Extrapolator\ge_AEGlobalValue.mq4>
#include <Extrapolator\ge_OwnerTree.mq4>
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Work Variables ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int 		Ix;
int 		Sx;
datetime	TimeSave;
datetime Shift3;
datetime	Shift5;
datetime Shift7;

double	Rates[];
double	TimeBuf1[];
double	TimeBuf2[];
double	TimeBuf3[];
double	TimeBuf4[];
double	TimeBuf5[];
double	TimeBuf6[];
double	TimeBuf7[];
double	TimeBuf8[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Initialization program Buffers ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	InitBufferam(int iBufferSize)
{
	ArrayResize(Rates,iBufferSize);
	ArrayResize(TimeBuf1,iBufferSize);
	ArrayResize(TimeBuf2,iBufferSize);
	ArrayResize(TimeBuf3,iBufferSize);
	ArrayResize(TimeBuf4,iBufferSize);
	ArrayResize(TimeBuf5,iBufferSize);
	ArrayResize(TimeBuf6,iBufferSize);
	ArrayResize(TimeBuf7,iBufferSize);
	ArrayResize(TimeBuf8,iBufferSize);
	//-->
	ArrayInitialize(TimeBuf1,EMPTY_VALUE);
	ArrayInitialize(TimeBuf2,EMPTY_VALUE);
	ArrayInitialize(TimeBuf3,EMPTY_VALUE);
	ArrayInitialize(TimeBuf4,EMPTY_VALUE);
	ArrayInitialize(TimeBuf5,EMPTY_VALUE);
	ArrayInitialize(TimeBuf6,EMPTY_VALUE);
	ArrayInitialize(TimeBuf7,EMPTY_VALUE);
	ArrayInitialize(TimeBuf8,EMPTY_VALUE);
	
	return;
}
void	EmptyBufferam()
{
	ArrayInitialize(Rates,EMPTY_VALUE);
	//ArrayInitialize(TimeBuf1,EMPTY_VALUE);
	//ArrayInitialize(TimeBuf2,EMPTY_VALUE);
// -->
	InitChart(FxView1);														// -->
	InitChart(FxView2);														// -->
	InitChart(FxView3);														// -->
	InitChart(FxView4);														// -->
	InitChart(FxView5);														// -->
	InitChart(FxView6);														// -->
	InitChart(FxView7);														// -->
	InitChart(FxView8);														// -->
	return;
}
void	DoneBufferam()
{
	ArrayResize(Rates,0);
	ArrayResize(TimeBuf1,0);
	ArrayResize(TimeBuf2,0);
	ArrayResize(TimeBuf3,0);
	ArrayResize(TimeBuf4,0);
	ArrayResize(TimeBuf5,0);
	ArrayResize(TimeBuf6,0);
	ArrayResize(TimeBuf7,0);
	ArrayResize(TimeBuf8,0);
	//---------------------------------
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Program Constants ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int		MaxPeriod=0;
int		CalcCount=0;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator initialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int init()
  {
  	MathSrand(TimeLocal());
  
//---- initialization program values  --------------------------------
	MaxPeriod=MathMax(Present,Present);//MathMax(ShortPrd,MathMax(SlowPrd,LongPrd)));
	InitBufferam(MaxCounter(Counter,MaxPeriod));
	CalcCount=InitCounter(Counter,MaxPeriod);
	TimeSave=0;									// Ticket  ,     
//---- initialization indicators -------------------------------------
	SetupChartLine(0,FxView1,0,2,"Line1");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(1,FxView2,0,2,"Line2");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(2,FxView3,0,2,"Line3");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(3,FxView4,0,2,"Line4");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(4,FxView5,0,2,"Line5");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(5,FxView6,0,2,"Line6");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(6,FxView7,0,2,"Line7");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(7,FxView8,0,2,"Line8");// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
   IndicatorShortName(IndicatorName);
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
	
	//SetIndexShift(0,-FuturePrd);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb
	SetIndexShift(1,ForeCast);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb
	SetIndexShift(3,ForeCast);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb
	SetIndexShift(5,ForeCast);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb
	SetIndexShift(7,ForeCast);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb

	//InitTicket(StringSubstr(IndicatorName,2,StringLen(IndicatorName)-2),50);					// -->
	InitTicket(StringSubstr(IndicatorName,2,StringLen(IndicatorName)-2));					// -->
	TimeSave=0;
	
	Shift3=TimeCurrent();
	Shift5=Shift3;
	Shift7=Shift3;

	InitOwnerTree(IndicatorName);
	if (svValueTree==0) InitMainGlobalValue(IndicatorName);
	else InitGlobalValue(IndicatorName);

//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator deinitialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int deinit()
  {
//----
	DoneBufferam();	
	DoneTicket();																					// -->
	if (svValueTree==0) {
		if (SearchOwnerTree(svValueTree+1)=="") DoneMainGlobalValue();
	}
	else DoneGlobalValue();
	DoneOwnerTree();
	
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Start defination ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start()
{
//	if (StartCalculate(Shift)==false)										// -->
	if (StartTicket(Shift)==false)											// -->
	{																					// -->
		if (!StartCounter(IndicatorName,Counter,CalcCount,MaxPeriod)) return(-1);
	}																					// -->
	else {																			// -->
		if (cwCalculated==true) return(0);									// -->
	}																					// -->
//------------------------------------------------------------------------------------
	EmptyBufferam();
//+-------------------------- Begin Cycle ---------------------------------------------------+\\
	ReadValueTicket(Shift,Ix);											// -->
	
	if (svValueTree==0) ReadyMainGlobalValue();
	else ReadyGlobalValue();
	ReadyValueTree();
	cwEmulated=svEmulate;
	
	int ShiftTree=svBarBuffered*4*svValueTree+Shift;
	if (TimeSave==0){
		CopySeries(Rates,MODE_CLOSE,Period(),ShiftTree+svBarBuffered*3);	
		Extrapolator(Rates,TimeBuf1,svPresent,TimeBuf2,svForeCast,svHarmonic,0);
	  	TimeBuf2[svForeCast]=TimeBuf1[0];
		ArrayCopy(TimeBuf7,TimeBuf1,0,0,svPresent);
		ArrayCopy(TimeBuf8,TimeBuf2,0,0,svForeCast+1);
		Shift7=Time[ShiftTree+svBarBuffered*3];
		CopySeries(Rates,MODE_CLOSE,Period(),ShiftTree+svBarBuffered*2);	
		Extrapolator(Rates,TimeBuf1,svPresent,TimeBuf2,svForeCast,svHarmonic,0);
	  	TimeBuf2[svForeCast]=TimeBuf1[0];
		ArrayCopy(TimeBuf5,TimeBuf1,0,0,svPresent);
		ArrayCopy(TimeBuf6,TimeBuf2,0,0,svForeCast+1);
		Shift5=Time[ShiftTree+svBarBuffered*2];
		CopySeries(Rates,MODE_CLOSE,Period(),ShiftTree+svBarBuffered*1);	
		Extrapolator(Rates,TimeBuf1,svPresent,TimeBuf2,svForeCast,svHarmonic,0);
	  	TimeBuf2[svForeCast]=TimeBuf1[0];
		ArrayCopy(TimeBuf3,TimeBuf1,0,0,svPresent);
		ArrayCopy(TimeBuf4,TimeBuf2,0,0,svForeCast+1);
		Shift3=Time[ShiftTree+svBarBuffered*1];
		TimeSave=Shift3;
	}
	
	datetime TimeCalc=Time[ShiftTree];
	//Print("Prev :",TimeToStr(TimeSave,TIME_DATE|TIME_MINUTES),"  Next :",TimeToStr(TimeCalc,TIME_DATE|TIME_MINUTES));
	int TimeCount=iBarShift(NULL,0,TimeSave)-iBarShift(NULL,0,TimeCalc);
	if (MathAbs(TimeCount)>svBarBuffered) {
		ArrayCopy(TimeBuf7,TimeBuf5,0,0,svPresent);
		ArrayCopy(TimeBuf8,TimeBuf6,0,0,svForeCast+1);
		Shift7=Shift5;
		ArrayCopy(TimeBuf5,TimeBuf3,0,0,svPresent);
		ArrayCopy(TimeBuf6,TimeBuf4,0,0,svForeCast+1);
		Shift5=Shift3;
		ArrayCopy(TimeBuf3,TimeBuf1,0,0,svPresent);
		ArrayCopy(TimeBuf4,TimeBuf2,0,0,svForeCast+1);
		Shift3=TimeSave;
		TimeSave=TimeCalc;
	}
	//Print(" Count : ",TimeCount);
	//  


	CopySeries(Rates,MODE_CLOSE,Period(),ShiftTree);	
  	Extrapolator(Rates,TimeBuf1,svPresent,TimeBuf2,svForeCast,svHarmonic,0);
  	TimeBuf2[svForeCast]=TimeBuf1[0];
  	ArrayCopy(FxView1,TimeBuf1,ShiftTree,0,svPresent);
  	ArrayCopy(FxView2,TimeBuf2,ShiftTree,0,svForeCast+1);
  	ArrayCopy(FxView3,TimeBuf3,iBarShift(NULL,0,Shift3),0,svPresent);
  	ArrayCopy(FxView4,TimeBuf4,iBarShift(NULL,0,Shift3),0,svForeCast+1);
  	ArrayCopy(FxView5,TimeBuf5,iBarShift(NULL,0,Shift5),0,svPresent);
  	ArrayCopy(FxView6,TimeBuf6,iBarShift(NULL,0,Shift5),0,svForeCast+1);
  	ArrayCopy(FxView7,TimeBuf7,iBarShift(NULL,0,Shift7),0,svPresent);
  	ArrayCopy(FxView8,TimeBuf8,iBarShift(NULL,0,Shift7),0,svForeCast+1);
  	
  	CalculateFinishedTicket();													// -->

//----
   return(0);
  }

//--------------------------------------------------------------------
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 InitCounter																		~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 int InitCounter(int iPreCount,int iMaxPeriod)
{
	// Rule 1
	//if ((Result==0)||(Result>Bars)) Result=Bars;
	int Result=MaxCounter(iPreCount,iMaxPeriod);
	// Rule 2
	if ((Result+iMaxPeriod)>Bars) Result=Bars-iMaxPeriod;
	// Rule 3
	if (Result<iMaxPeriod) Result=0;
	else Result=Result+iMaxPeriod;
	return(Result);
}
//------------------------------------------ StartCounter --------------------------
bool StartCounter(string WindowName,int iPreCount,int& iCalcCount,int iMaxPeriod)
{
	if ((iPreCount>iCalcCount)||(iPreCount==0)) iCalcCount=InitCounter(iPreCount,iMaxPeriod);
	if (iCalcCount==0) 
	{
		Alert(WindowName+" "+Symbol()+"("+Period()+") - Limited Calculate Period");
		return(false);
	}
	return(true);
	//int iBarCount=IndicatorCounted();
	//if (iBarCount>0) return(true);
	//Print("StartCounter");
	return(false);
}
//------------------------------------------ StartCounter --------------------------
int MaxCounter(int iPreCount,int iMaxPeriod)
{
	int Result=iPreCount;
	// Rule 1
	//if ((Result==0)||(Result>Bars)) Result=Bars;
	if (Result==0) Result=Bars-1;
	if (Result<iMaxPeriod) Result=iMaxPeriod;
	return(Result+iMaxPeriod);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 Style active Line																~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void SetupChartLine(int Index,double& ViewAy[],int Style,int Width,string Label)
{
	switch(Style)
	{
		case 0 : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
		case 1 : SetIndexStyle(Index,DRAW_HISTOGRAM,STYLE_SOLID,Width);break;
		case 2 : SetIndexStyle(Index,DRAW_ARROW,STYLE_SOLID,Width);break;
		default : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
	}
	if (Label!="") SetIndexLabel(Index,Label);
	SetIndexBuffer(Index,ViewAy);
	return(0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~																CopySeries																	~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CopySeries(double& CopyRate[],int SeriesIndex,int TimeFrame,int iShift)
{
/*
	MODE_OPEN 0   	
	MODE_LOW 1   
	MODE_HIGH 2   
	MODE_CLOSE 3   
	MODE_VOLUME 4  ( ,  ) 
	MODE_TIME 5    
*/
	for (int Cx=0;Cx<ArraySize(CopyRate);Cx++)
	{
		switch (SeriesIndex)
		{
		case MODE_OPEN 	: CopyRate[Cx]=iOpen(NULL,TimeFrame,Cx+iShift);break;
		case MODE_LOW 		: CopyRate[Cx]=iLow(NULL,TimeFrame,Cx+iShift);break;
		case MODE_HIGH 	: CopyRate[Cx]=iHigh(NULL,TimeFrame,Cx+iShift);break;
		case MODE_CLOSE 	: CopyRate[Cx]=iClose(NULL,TimeFrame,Cx+iShift);break;
		case MODE_VOLUME 	: CopyRate[Cx]=iVolume(NULL,TimeFrame,Cx+iShift);break;
		case MODE_TIME 	: CopyRate[Cx]=iTime(NULL,TimeFrame,Cx+iShift);break;
		//PRICE_MEDIAN 4  , (high+low)/2 
		//PRICE_TYPICAL 5  , (high+low+close)/3 
		//PRICE_WEIGHTED 6   , (high+low+close+close)/4 
		}
	}
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void InitChart(double& ayShift[])									// 
{
	if (ArraySize(ayShift)>0) ArrayInitialize(ayShift,EMPTY_VALUE);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

